
#################
# Mob Particles #
#################
execute at @e[tag=Eyeball] run particle minecraft:block redstone_block ~ ~1 ~ 0 0 0 0.05 2 normal

#################
#  Hurt Sounds  #
#################

# For mobs that have a special death effect, keep track of their health in a scoreboard value
execute as @e[tag=deathEffect] store result score @s mobHealth run data get entity @s Health 1

execute as @e[tag=Vampire,nbt={HurtTime:10s},scores={mobHealth=11..}] at @s run playsound minecraft:entity.phantom.bite hostile @a ~ ~ ~ 1 1.5 0
execute as @e[tag=Eyeball,nbt={HurtTime:10s},scores={mobHealth=11..}] at @s run playsound minecraft:entity.slime.attack hostile @a ~ ~ ~ 1 1 0
execute as @e[tag=Werewolf,nbt={HurtTime:10s},scores={mobHealth=11..}] at @s run playsound minecraft:entity.wolf.growl hostile @a ~ ~ ~ 1 1.2 0

##################
#  Death Sounds  #
##################

execute as @e[tag=Vampire,scores={mobHealth=..10}] at @s run playsound minecraft:entity.phantom.bite hostile @a ~ ~ ~ 1 1 0
execute as @e[tag=Vampire,scores={mobHealth=..10}] at @s run kill @s
execute as @e[tag=Eyeball,scores={mobHealth=..10}] at @s run playsound minecraft:entity.slime.death hostile @a ~ ~ ~ 1 1 0
execute as @e[tag=Eyeball,scores={mobHealth=..10}] at @s run kill @e[type=vex,distance=..1]
execute as @e[tag=Eyeball,scores={mobHealth=..10}] at @s run kill @s
execute as @e[tag=Werewolf,scores={mobHealth=..10}] at @s run playsound minecraft:entity.wolf.death hostile @a ~ ~ ~ 1 1 0
execute as @e[tag=Werewolf,scores={mobHealth=..10}] at @s run kill @s

#################
# Mob Behaviors #
#################

# Vampire instakill
execute as @e[tag=Vampire,nbt={HurtTime:10s}] at @s if entity @a[distance=..4,nbt={SelectedItem:{tag:{display:{Name:"{\"text\":\"§cSacred Stake\"}"}}}}] run playsound minecraft:entity.bat.death hostile @a ~ ~ ~ 1 0.5 0
execute as @e[tag=Vampire,nbt={HurtTime:10s}] at @s if entity @a[distance=..4,nbt={SelectedItem:{tag:{display:{Name:"{\"text\":\"§cSacred Stake\"}"}}}}] run summon firework_rocket ~ ~ ~ {LifeTime:1,FireworksItem:{id:firework_rocket,Count:1,tag:{Fireworks:{Explosions:[{Type:0,Colors:[I;16711680]}]}}}}
execute as @e[tag=Vampire,nbt={HurtTime:10s}] at @s if entity @a[distance=..4,nbt={SelectedItem:{tag:{display:{Name:"{\"text\":\"§cSacred Stake\"}"}}}}] run kill @s

# Vampire teleportation
scoreboard players set @e[tag=Vampire,nbt={HurtTime:10s}] vanishTime 30
scoreboard players remove @e[scores={vanishTime=1..30}] vanishTime 1
execute at @e[scores={vanishTime=29}] run summon minecraft:bat ~ ~ ~ {Invulnerable:1}
execute at @e[scores={vanishTime=29}] run particle minecraft:smoke ~ ~ ~ 0 1 0 0.4 20 force
execute as @e[scores={vanishTime=29}] at @s run data merge entity @s {NoAI:1,Invulnerable:1}
execute as @e[scores={vanishTime=28}] at @s run tp @s ~ ~50 ~
execute as @e[scores={vanishTime=10}] at @s run tp @s @e[type=bat,sort=nearest,limit=1]
execute as @e[scores={vanishTime=10}] at @s run tp @e[type=bat,sort=nearest,limit=1] ~ ~-1000 ~
execute as @e[scores={vanishTime=7..9}] at @s run data merge entity @s {NoAI:0}
execute as @e[scores={vanishTime=5}] at @s run data merge entity @s {Invulnerable:0}
execute at @e[scores={vanishTime=6..10}] run particle minecraft:smoke ~ ~ ~ 0 1 0 0.4 10 force

# Werewolf transformation
execute as @e[tag=Werewolf_P] at @s if entity @a[distance=..7] run summon husk ~ ~ ~ {Silent:1b,Health:35f,Tags:["deathEffect","Werewolf"],CustomName:"{\"text\":\"Werewolf\",\"color\":\"red\"}",HandItems:[{id:"minecraft:quartz",Count:1b,tag:{display:{Name:"{\"text\":\"Feral Claws\",\"color\":\"red\"}"},Enchantments:[{id:"minecraft:knockback",lvl:1}],AttributeModifiers:[{AttributeName:"generic.movementSpeed",Name:"generic.movementSpeed",Amount:0.05,Operation:1,UUIDLeast:33662,UUIDMost:687909,Slot:"mainhand"}]}},{}],HandDropChances:[0.1F,0.85F],ArmorItems:[{},{},{id:"minecraft:leather_chestplate",Count:1b,tag:{display:{color:7694426}}},{id:"minecraft:player_head",Count:1b,tag:{SkullOwner:{Id:"49110d51-7352-4552-8fa1-6eb96a12a490",Properties:{textures:[{Value:"eyJ0ZXh0dXJlcyI6eyJTS0lOIjp7InVybCI6Imh0dHA6Ly90ZXh0dXJlcy5taW5lY3JhZnQubmV0L3RleHR1cmUvM2E3ZWVlMzExODU5ZGQ4ZDEyNGUyZjRmMDUwOTIzNmI1OTY3NWYyZGY0Y2U4MTI2MjQyMzgwZGY3Y2UxNzkifX19"}]}}}}],ArmorDropChances:[0.85F,0.85F,0.0F,0.0F],Attributes:[{Name:generic.maxHealth,Base:35},{Name:generic.movementSpeed,Base:0.35},{Name:generic.knockbackResistance,Base:0.5}]}
execute as @e[tag=Werewolf_P] at @s if entity @a[distance=..7] run playsound minecraft:entity.wither.break_block hostile @a ~ ~ ~ 1 1 0
execute as @e[tag=Werewolf_P] at @s if entity @a[distance=..7] run playsound minecraft:entity.wolf.howl hostile @a ~ ~ ~ 1 0.8 0
execute as @e[tag=Werewolf_P] at @s if entity @a[distance=..7] run particle minecraft:flame ~ ~0.5 ~ 0.5 1 0.5 0.01 40 normal
execute as @e[tag=Werewolf_P] at @s if entity @a[distance=..7] run tp @s ~ ~-1000 ~
